<?php
header('Content-Type: text/html; charset=utf-8');
/**
 * Encoding utf8
 * Ярослав - th-net at ya.ru
 * Web-интерфейс для просмотря логов чата CommFort v.3.0.2
 * Для работы требуется разместить файл на работающем Web-сервере и изменить путь к вашим логфайлам. Остальные настройки "по вкусу".
 * http://www.commfort.com/ru/forum/viewtopic.php?f=28&t=6618 — подробности и новые версии.
 */
// Настойки менять тут
$rows_per_page = 10000; // Количество записей выводимых на одной странице
$logdir = 'C:/Documents and Settings/All Users/Application Data/CommFort_server/Logs/'; // Каталог логфайлов
$show_id = true; // Поставить true если нужно отображать ID компьютера
$highlight_bg = true; // true - выделяется строки цветом фона; false - выделяет строки цветом текста

$log_events = array( // названия и цвета событий
    -100 => array('name' => 'Авторизация', 'color' => 'green'),
    10 => array('name' => 'Создание канала', 'color' => 'lightgreen'),
    11 => array('name' => 'Закрытие канала', 'color' => 'navy'),
    12 => array('name' => 'Настройки канала', 'color' => 'green'),
    13 => array('name' => 'Наказание', 'color' => 'red'),
    14 => array('name' => 'Амнистия', 'color' => 'magenta'),
    15 => array('name' => 'Изменение прав', 'color' => 'lightblue'),
    16 => array('name' => 'Удаление учётной записи', 'color' => 'blue'),
    17 => array('name' => 'Изменение пароля', 'color' => 'cyan'),
    18 => array('name' => 'Активация учёток', 'color' => 'lightblue'),
    19 => array('name' => 'Отклонение активации', 'color' => 'brown'),
    20 => array('name' => 'Удаление объявления', 'color' => 'gray'),
    
    22 => array('name' => 'Настройки авторизации', 'color' => 'lightblue'),
    23 => array('name' => 'Автонаказание', 'color' => 'red'),
    24 => array('name' => 'Регистрация', 'color' => 'lime'),
    
    
    27 => array('name' => 'Зачистка', 'color' => 'orange'),

    29 => array('name' => 'Изменение статуса активации', 'color' => 'brown'),
);

// Далее ничего не менять.

function grab_title($logfile){
    preg_match('/(?:Events|Authorisation|System)_?([0-9_]*)\./i',$logfile,$matches);
    return $matches[1]?$matches[1]:'Объединённый';
}

?>
<html><head>
<style>
body{background-color:white}
a.current{background-color:yellow}
table.content{width:100%;border:solid thin black;border-collapse:collapse;}
table.content th {border:solid thin green}
table.content td {border:solid white;border-width:1px 0;padding: 2 5px;}
.err_message{border-radius: 10px; border: solid thin red;padding: 0px 5px; width: 500px; text-align: center; margin: 0px auto 5px}

</style>
<script>
function go(to){
	if (to == '') window.location.reload();
	window.location = '?logfile='+to;
}
</script>
</head>
<body>
<?php

$events = array(
);


$sys_logs = glob($logdir."System*");
$event_logs = glob($logdir."Events/Events*");
$auth_logs = glob($logdir."Authorisation/Authorisation*");
$logfile_id = 'event_'.(count($event_logs)-1);
if (!empty($_GET['logfile'])){
    $logfile_id = $_GET['logfile'];
}

?>
Системные события: <select onChange="go(this.value);"><option value="">Не выбрано...</option>
<?php
foreach ($sys_logs as $key => $logfile){
    printf('<option value="sys_%d" %s>%s</option>',$key,(($logfile_id=='sys_'.$key)?'selected="selected"':''),grab_title($logfile));
}
?>
</select>Общие события:  <select onChange="go(this.value);"><option value="">Не выбрано...</option>
    <?php foreach ($event_logs as $key => $logfile){
        printf('<option value="event_%d" %s>%s</option>',$key,(($logfile_id=='event_'.$key)?'selected="selected"':''),grab_title($logfile));
    }?>
</select>Авторизации: <select onChange="go(this.value);"><option value="">Не выбрано...</option>
    <?php foreach ($auth_logs as $key => $logfile){
        printf('<option value="auth_%d" %s>%s</option>',$key,(($logfile_id=='auth_'.$key)?'selected="selected"':''),grab_title($logfile));
    }?>
</select>
<br />Страницы : 
<?php
$logtype = substr($logfile_id,0,(strpos($logfile_id,'_'))).'_logs'; // Определяем массив логов
$delta = substr($logfile_id,strrpos($logfile_id,'_')+1); // выделяем смещение лога
$err_messsage = '';
if (empty(${$logtype})){
    $logtype = 'event_logs';
    $err_messsage .= 'Указанного типа логов не существует. Выбран лог событий.<br>';  
}

if (count(${$logtype}) <= $delta){
    $delta = count(${$logtype})-1;
    $err_messsage .= 'Указанной даты не существует. Выбрана последняя дата.<br>';
}

$log = file(${$logtype}[$delta]);
$k = 0;
if (isset($_GET['page'])){
	$curpage = (int) $_GET['page'];
} else {
	$curpage = 1;
}

for ($p = 0;$p < count($log)/$rows_per_page;$p++){
	if($p+1 == $curpage) $page_class="class='current'"; else $page_class='';
	printf("<a href=?logfile=%s&page=%d %s>%d</a> | ",$logfile_id,$p+1,$page_class,$p+1);
}
?>
<?php if (!empty($err_messsage)){?>
    <div class="err_message"><?=$err_messsage?></div>
<?php }?>

<table class="content"><tr class="header"><th>Событие</th><th>Дата</th><th>Уч.запись</th><th>IP/ID</th><th>Описание</th></tr>
<?php
if (isset($_GET['page'])){
	$i = ($curpage-1) * $rows_per_page;
}

foreach ($log as $row){

    $matches = array();
    $patterns = array(
        'создал канал','закрыл канал','изменил настройки канала',
        'ограничил пользователя', 'снял ограничение с пользователя','изменил права для учетной записи',
        'удалил учетную запись','изменил пароль для учетной записи','удалил объявление, опубликованное пользователем',
        'изменил настройки авториазции','ограничен автоматически за сообщение','запросил регистрацию','удалил сообщение в канале',
        'активировал учетные записи пользователей:','отклонил активацию учетных записей пользователей:','изменил статус активации пользователей:'
    );
	
	if ($ii++ < $i) continue;
	//$row = iconv('UTF-16', 'UTF-8', $row);
	if (strlen($row) < 10) continue; // log entry can't be less than at least 10 symbols
	if ($row[0] == "\x00") $row = substr($row, 1);
	$row_utf8 = mb_convert_encoding($row, 'UTF-8', 'UTF-16LE');
	if ($logtype == 'auth_logs'){
	    preg_match('/(\s)?([0-9.]{10})\s*([0-9.\:]{7,8})\|(.*)\|([0-9.]*)\|([0-9a-f]*)/i',$row_utf8,$matches);
	    $matches[1] = -100;
	} else {
        preg_match('/^E([0-9]{2})\s\[([0-9.]{10})\s*([0-9.\:]{9,12})\]\s(?:(.*)\s)?\((?:IP\s=\s)?([0-9.]*)(?:,\sClientID\s=\s([0-9a-f]*))?\)\:\s(.*)$/iU',$row_utf8,$matches);
		//      event^^^^^^^^^^^  ^^date^^^^^time^^ ^user^
		//if ($matches[1] != 13 && $matches[1] != 14) continue; //Раскомментировать для показа только логов наказаний и амнистий
	}
	//var_dump($matches);die;
    setlocale(LC_TIME, "rus");
    $date = strftime('<nobr>%d %a %H:%M:%S</nobr>',strtotime($matches[2]." ".$matches[3]));
	$date = iconv('CP1251','UTF-8',$date);
    $events[$matches[1]]++;
    $comment = preg_replace('/('.implode('|',$patterns).')(.*)/','\1 <b><u>\2</u></b>',htmlspecialchars($matches[7]));

    printf("<tr class='data' style='%scolor: %s;'><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>\n",
        ($highlight_bg?'background-':''),
        (isset($log_events[$matches[1]])?$log_events[$matches[1]]['color']:'inherit'),
        (isset($log_events[$matches[1]])?$log_events[$matches[1]]['name']:'Тип '.$matches[1]),
        $date,
        htmlspecialchars($matches[4]),
        '<b>'.($matches[5]=='0.0.0.0'?'Серверный плагин?':$matches[5]).'</b>'.(($show_id&&$matches[6])?' ('.$matches[6].')':''),
        $comment
    );
        
    if (++$j == $rows_per_page) break;
}
?>
<div>События : 
<?php
ksort($events);
foreach ($events as $key => $count)
    printf("<span style='color: %s;'><nobr>%s (%d)</nobr></span> | ",
        (isset($log_events[$key])?$log_events[$key]['color']:'black'),
        (isset($log_events[$key])?$log_events[$key]['name']:'Тип '.$key),
        $count
    );
?>
</div></table>
<!-- Вышестоящая строка есть грязный хак для вывода списка событий перед таблицей. Дети, не пытайтесь повторить такое самостоятельно. -->
Страницы: 
<?php
for ($p = 0;$p < count($log)/$rows_per_page;$p++){
    if($p+1 == $curpage) $page_class="class='current'"; else $page_class='';
    printf("<a href=?logfile=%s&page=%d %s>%d</a> | ",$logfile_id,$p+1,$page_class,$p+1);
}
?>
</body>
</html>